<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglImplementationTester.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_3bddf74631e93c4b493dedcb5ed12a12.html">implementation</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglImplementationTester.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglImplementationTester_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLIMPLEMENTATIONTESTER_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLIMPLEMENTATIONTESTER_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglApiTester_8hpp.html">tiglApiTester.hpp</a>&quot;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALG_VERTEX_TYPE, <span class="keyword">typename</span> ALG_COMBINER&gt;</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classTIGLApiTester.html#abd94a03f393df87c989b5aca4e26c98f">   53</a></span>&#160;<a class="code" href="classTIGLApiTester.html#abd94a03f393df87c989b5aca4e26c98f">TIGLApiTester&lt;ALG_VERTEX_TYPE, ALG_COMBINER&gt;::TIGLApiTester</a>(<span class="keywordtype">bool</span> isDirected, uint64_t numTotalVertices, uint_fast32_t idDevice, uint_fast32_t totalDevices,</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;      <span class="keywordtype">int</span> allocThreads) :</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      <a class="code" href="classTIGL.html">TIGL</a>&lt;ALG_VERTEX_TYPE, ALG_COMBINER&gt;(isDirected, numTotalVertices, idDevice, totalDevices, allocThreads)</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;{</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALG_VERTEX_TYPE, <span class="keyword">typename</span> ALG_COMBINER&gt;</div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classTIGLApiTester.html#a357fcce3cfa65b607b3f2bb9e94142f8">   68</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLApiTester.html#a357fcce3cfa65b607b3f2bb9e94142f8">TIGLApiTester&lt;ALG_VERTEX_TYPE, ALG_COMBINER&gt;::getVertex</a>(ID_TYPE <span class="keywordtype">id</span>, ALG_VERTEX_TYPE *pVertex)</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;{</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;   VERTEX_ITERATOR it;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;   <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;getVertex(<span class="keywordtype">id</span>, &amp;it) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;   *pVertex = *it;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALG_VERTEX_TYPE, <span class="keyword">typename</span> ALG_COMBINER&gt;</div>
<div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="classTIGLApiTester.html#a97fa334a3aa9c52e3aef64ea1849a519">   86</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLApiTester.html#a97fa334a3aa9c52e3aef64ea1849a519">TIGLApiTester&lt;ALG_VERTEX_TYPE, ALG_COMBINER&gt;::testMutationManagerModule</a>(<span class="keywordtype">char</span> *fileName)</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;{</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;   <span class="keywordflow">if</span> (this-&gt;mutateLocalSubgraphFromFile(fileName) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;   {</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot read graph file &quot;</span> &lt;&lt; fileName &lt;&lt; endl;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;   }</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   vector&lt;ALG_VERTEX_TYPE&gt; refVerticesList;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="group__file__io.html#ga07b37b5c84ed6aa573ff6ed56bcb0c5c">TIGLRwReadAdjList</a>(refVerticesList, fileName) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot read graph file &quot;</span> &lt;&lt; fileName &lt;&lt; endl;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;   }</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="comment">// now checking the graph</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   uint_fast32_t i;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   <span class="keywordtype">bool</span> stat = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;   <span class="keywordflow">for</span> (i = 0; i &lt; refVerticesList.size(); ++i)</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   {</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;      VERTEX_ITERATOR itRef = refVerticesList.begin() + i;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;      uint_fast32_t <span class="keywordtype">id</span> = itRef-&gt;getId();</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;      VERTEX_ITERATOR it2;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;      <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;getVertex(<span class="keywordtype">id</span>, &amp;it2) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;      {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;         OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;ERROR vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot; does not exist &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;         stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;      }</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;      <span class="keywordflow">if</span> (stat == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;      {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;         <span class="comment">// now comparing the edges</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;         <span class="keywordflow">if</span> (it2-&gt;getNumOutEdges() != itRef-&gt;getNumOutEdges())</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;         {</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;ERROR: vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot;: edges mismatch&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;         }</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;      }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;      <span class="comment">// comparing the edges themeselves</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   }</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   <span class="keywordflow">if</span> (stat == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   cout &lt;&lt; <span class="stringliteral">&quot;-- ADD_EMPTY_VERTEX, ADD_EDGE verified successfully&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   <span class="comment">// second test REMOVE_VERTEX, REMOVE_EDGE : removing all vertices that are multiple of 10</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;   uint_fast32_t originalNumVertices = this-&gt;dataManager-&gt;size();</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;   <span class="keywordflow">for</span> (uint_fast32_t i = 0; i &lt; originalNumVertices; i += 10)</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;   {</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;      <span class="keywordtype">int</span> thread = <a class="code" href="group__misc__tools.html#gaba06990768c6b572ca3f69029334a9df">omp_get_thread_num</a>();</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;      <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> mess(this-&gt;rank);</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;      mess.<a class="code" href="classTIGLMutationMessage.html#a59efe7d8e43b57679710b703462e809d">writeSimpleVertexMessage</a>(REMOVE_VERTEX, &amp;i);</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      this-&gt;dataManager-&gt;pushLocalMutationMessage(mess, thread);</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;      <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;numLocalMutationMessage(thread) &gt;= MAX_MUTATION_MESSAGE)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;         this-&gt;mutationManager-&gt;processMutationMessages(thread);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   }</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   uint_fast32_t numRemovedVertices = originalNumVertices % 10 ? originalNumVertices / 10 + 1 : originalNumVertices / 10;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   <span class="comment">// now executing all threads</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> thread = 0; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      this-&gt;mutationManager-&gt;processMutationMessages(thread);</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;   <span class="comment">// checking the vertices size</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;   <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;size() != originalNumVertices - numRemovedVertices)</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;   {</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;ERROR REMOVE_VERTEX: size mismatch after remove : (&quot;</span> &lt;&lt; this-&gt;dataManager-&gt;size() &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; originalNumVertices - numRemovedVertices &lt;&lt; <span class="stringliteral">&quot;)&quot;</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            &lt;&lt; endl;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;   }</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;   <span class="keywordflow">for</span> (i = 0; i &lt; originalNumVertices; i += 10)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   {</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;      VERTEX_ITERATOR itRef = refVerticesList.begin() + i;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;      uint_fast32_t <span class="keywordtype">id</span> = itRef-&gt;getId();</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;      <span class="keywordflow">if</span> (<span class="keywordtype">id</span> % 10 == 0)</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;      {</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;         <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;exist(<span class="keywordtype">id</span>))</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;         {</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;ERROR REMOVE_VERTEX: vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot;is not removed&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;         }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;      }</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;      <span class="keywordflow">else</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;      {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;         VERTEX_ITERATOR it2;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;         <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;getVertex(<span class="keywordtype">id</span>, &amp;it2) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;         {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;ERROR REMOVE_VERTEX: vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot;is removed&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;         }</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;         <span class="keywordflow">if</span> (stat == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;         {     <span class="comment">// now comparing the edges</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            vector&lt;ID_TYPE&gt; nbrs;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            itRef-&gt;getChildren(nbrs);</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            uint_fast32_t numNbrs = 0;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            <span class="keywordflow">for</span> (<span class="keyword">typename</span> vector&lt;ID_TYPE&gt;::iterator itNbr = nbrs.begin(); itNbr != nbrs.end(); ++itNbr)</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;               <span class="keywordflow">if</span> ((*itNbr) % 10)</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                  numNbrs++;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;            <span class="keywordflow">if</span> (it2-&gt;getNumOutEdges() != numNbrs)</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            {</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;               OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;               cout &lt;&lt; <span class="stringliteral">&quot;ERROR: vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot;: edges mismatch after removal&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;               stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            }</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;         }</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;      }</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;   }</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;   cout &lt;&lt; <span class="stringliteral">&quot;-- REMOVE_VERTEX, REMOVE_EDGE verified successfully&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;   <span class="comment">// now returning ADD_VERTEX, MIGRATE_VERTEX</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;   <span class="keywordflow">for</span> (i = 0; i &lt; originalNumVertices; i += 10)</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;   {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;      <span class="keywordtype">int</span> thread = <a class="code" href="group__misc__tools.html#gaba06990768c6b572ca3f69029334a9df">omp_get_thread_num</a>();</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;      VERTEX_ITERATOR itRef = refVerticesList.begin() + i;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;      <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> mess(this-&gt;rank);</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;      mess.<a class="code" href="classTIGLMutationMessage.html#af860e1dbf7c39e451d6eaf39d2c34713">writeVertexMessage</a>(ADD_VERTEX, &amp;(*itRef));</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;      this-&gt;dataManager-&gt;pushLocalMutationMessage(mess, thread);</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;      <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;numLocalMutationMessage(thread) &gt;= MAX_MUTATION_MESSAGE)</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;         this-&gt;mutationManager-&gt;processMutationMessages(thread);</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;   }</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;   <span class="comment">// now executing all threads for writing vertices</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> thread = 0; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;      this-&gt;mutationManager-&gt;processMutationMessages(thread);</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;   <span class="comment">// reconnecting edges between recovered vertices and their neigbors</span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;   <span class="keywordflow">for</span> (i = 0; i &lt; originalNumVertices; i += 10)</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;   {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;      <span class="keywordtype">int</span> thread = <a class="code" href="group__misc__tools.html#gaba06990768c6b572ca3f69029334a9df">omp_get_thread_num</a>();</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;      VERTEX_ITERATOR itRef = refVerticesList.begin() + i;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;      <span class="keywordflow">if</span> (itRef-&gt;getId() % 10 == 0)</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;      {</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;         <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> mess(this-&gt;rank);</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;         vector&lt;ID_TYPE&gt; nbrs;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;         itRef-&gt;getChildren(nbrs);</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;         <span class="keywordflow">for</span> (<span class="keyword">typename</span> vector&lt;ID_TYPE&gt;::iterator itNbr = nbrs.begin(); itNbr != nbrs.end(); ++itNbr)</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;         {</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            EDGE_TYPE newEdge(itRef-&gt;getId());</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;            ID_TYPE nbrId = *itNbr;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;            <span class="comment">//newVertex.addEdge(newEdge);</span></div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;            <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> message(this-&gt;rank);   <span class="comment">//(ADD_OUT_EDGE, rank, &amp;newEdge , &amp;id);</span></div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            message.<a class="code" href="classTIGLMutationMessage.html#ab9271622ced744b984d48b1d7279aa9c">writeEdgeMessage</a>(ADD_OUT_EDGE, &amp;newEdge, &amp;nbrId);</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            this-&gt;dataManager-&gt;pushLocalMutationMessage(message, thread);</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;         }</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;         <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;numLocalMutationMessage(thread) &gt;= MAX_MUTATION_MESSAGE)</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            this-&gt;mutationManager-&gt;processMutationMessages(thread);</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;      }</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;   }</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;   <span class="comment">// now executing all threads for writing vertices</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> thread = 0; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;      this-&gt;mutationManager-&gt;processMutationMessages(thread);</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;   <span class="comment">// now checking the graph</span></div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;   <span class="keywordflow">for</span> (i = 0; i &lt; refVerticesList.size(); ++i)</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;   {</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;      VERTEX_ITERATOR itRef = refVerticesList.begin() + i;</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;      uint_fast32_t <span class="keywordtype">id</span> = itRef-&gt;getId();</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;      VERTEX_ITERATOR it2;</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;      <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;getVertex(<span class="keywordtype">id</span>, &amp;it2) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;      {</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;ERROR vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot; does not exist &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;         stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;      }</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;      <span class="keywordflow">if</span> (stat == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;      {</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;         <span class="comment">// now comparing the edges</span></div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;         <span class="keywordflow">if</span> (it2-&gt;getNumOutEdges() != itRef-&gt;getNumOutEdges())</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;         {</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;ERROR: vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot;: edges mismatch: (&quot;</span> &lt;&lt; it2-&gt;getNumOutEdges() &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; itRef-&gt;getNumOutEdges() &lt;&lt; <span class="stringliteral">&quot;) &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;         }</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;      }</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;      <span class="comment">// comparing the edges themeselves</span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;   }</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;   <span class="keywordflow">if</span> (stat == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;   cout &lt;&lt; <span class="stringliteral">&quot;-- ADD_VERTEX verified successfully&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;   cout &lt;&lt; <span class="stringliteral">&quot;-- mutation manager test DONE !&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;}</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALG_VERTEX_TYPE, <span class="keyword">typename</span> ALG_COMBINER&gt;</div>
<div class="line"><a name="l00304"></a><span class="lineno"><a class="line" href="classTIGLApiTester.html#a5c78bf9268bba7e3603466bc45bba2a9">  304</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLApiTester.html#a5c78bf9268bba7e3603466bc45bba2a9">TIGLApiTester&lt;ALG_VERTEX_TYPE, ALG_COMBINER&gt;::testMpiMutationManagerModule</a>(int_fast32_t readDev, <span class="keywordtype">char</span> *fileName)</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;{</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;   <span class="keywordflow">if</span> (this-&gt;networkReadGraph(readDev, fileName) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;   {</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;ERROR: in  networkReadGraph&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;   }</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;   <span class="comment">// now checking the graph consistency</span></div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;   vector&lt;ALG_VERTEX_TYPE&gt; refVerticesList;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="group__file__io.html#ga07b37b5c84ed6aa573ff6ed56bcb0c5c">TIGLRwReadAdjList</a>(refVerticesList, fileName) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;   {</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;ERROR: cannot read graph file &quot;</span> &lt;&lt; fileName &lt;&lt; endl;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;   }</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;   <span class="comment">// now checking the graph</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;   uint_fast32_t i;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;   <span class="keywordtype">bool</span> stat = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;   uint_fast32_t totalVertices = refVerticesList.size();</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;   OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;   <span class="keywordflow">for</span> (i = 0; i &lt; totalVertices; ++i)</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;   {</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;      VERTEX_ITERATOR itRef = refVerticesList.begin() + i;</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;      uint_fast32_t <span class="keywordtype">id</span> = itRef-&gt;getId();</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;      uint_fast32_t dev = <a class="code" href="group__comm__routines.html#gae2623e3f83f9c72f406cfd93f6156348">TIGLCommunicationFindDevice</a>(<span class="keywordtype">id</span>, totalVertices, this-&gt;numDevices);</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;      <span class="keywordflow">if</span> (dev != this-&gt;rank)</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;         <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;      VERTEX_ITERATOR it2;</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;      <span class="keywordflow">if</span> (this-&gt;dataManager-&gt;getVertex(<span class="keywordtype">id</span>, &amp;it2) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;      {</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;         OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;ERROR vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot; does not exist &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;         stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;      }</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;      <span class="keywordflow">if</span> (stat == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;      {</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;         <span class="comment">// now comparing the edges</span></div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;         <span class="keywordflow">if</span> (it2-&gt;getNumOutEdges() != itRef-&gt;getNumOutEdges())</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;         {</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;ERROR: vertex &quot;</span> &lt;&lt; <span class="keywordtype">id</span> &lt;&lt; <span class="stringliteral">&quot;: edges mismatch&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            stat = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;         }</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;      }</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;      <span class="comment">// comparing the edges themeselves</span></div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;   }</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;   <span class="keywordflow">if</span> (stat == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;}</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLIMPLEMENTATIONTESTER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLApiTester_html_abd94a03f393df87c989b5aca4e26c98f"><div class="ttname"><a href="classTIGLApiTester.html#abd94a03f393df87c989b5aca4e26c98f">TIGLApiTester::TIGLApiTester</a></div><div class="ttdeci">TIGLApiTester(bool isDirected, uint64_t numTotalVertices, uint_fast32_t idDevice=0, uint_fast32_t totalDevices=1, int allocThreads=NUM_OMP_THREADS)</div><div class="ttdoc">Destructor performs necessary memory release. </div><div class="ttdef"><b>Definition:</b> tiglImplementationTester.hpp:53</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_af860e1dbf7c39e451d6eaf39d2c34713"><div class="ttname"><a href="classTIGLMutationMessage.html#af860e1dbf7c39e451d6eaf39d2c34713">TIGLMutationMessage::writeVertexMessage</a></div><div class="ttdeci">bool writeVertexMessage(MUTATION_MESSAGE_CODE code, CVertex *vertex)</div><div class="ttdoc">Procedure for writing ADD/MIGRATE vertex messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:591</div></div>
<div class="ttc" id="classTIGLApiTester_html_a5c78bf9268bba7e3603466bc45bba2a9"><div class="ttname"><a href="classTIGLApiTester.html#a5c78bf9268bba7e3603466bc45bba2a9">TIGLApiTester::testMpiMutationManagerModule</a></div><div class="ttdeci">bool testMpiMutationManagerModule(int_fast32_t readDev, char *fileName)</div><div class="ttdoc">Test procedure for mutation manager with multiple devices. </div><div class="ttdef"><b>Definition:</b> tiglImplementationTester.hpp:304</div></div>
<div class="ttc" id="group__file__io_html_ga07b37b5c84ed6aa573ff6ed56bcb0c5c"><div class="ttname"><a href="group__file__io.html#ga07b37b5c84ed6aa573ff6ed56bcb0c5c">TIGLRwReadAdjList</a></div><div class="ttdeci">bool TIGLRwReadAdjList(vector&lt; VertexClass &gt; &amp;verticesList, char *fileName)</div><div class="ttdoc">Reads the adjacency list of vertices from a file. </div><div class="ttdef"><b>Definition:</b> tiglRWReadAdjList.hpp:63</div></div>
<div class="ttc" id="group__comm__routines_html_gae2623e3f83f9c72f406cfd93f6156348"><div class="ttname"><a href="group__comm__routines.html#gae2623e3f83f9c72f406cfd93f6156348">TIGLCommunicationFindDevice</a></div><div class="ttdeci">int_fast32_t TIGLCommunicationFindDevice(uint_fast32_t vtxID, uint_fast32_t totalNumVertices, uint_fast32_t numDevices)</div><div class="ttdoc">Computes the owner device of a vertex. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationFindDev.cpp:54</div></div>
<div class="ttc" id="classTIGL_html"><div class="ttname"><a href="classTIGL.html">TIGL</a></div><div class="ttdoc">Top level class for the TIGL engine  . </div><div class="ttdef"><b>Definition:</b> tigl.hpp:88</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_ab9271622ced744b984d48b1d7279aa9c"><div class="ttname"><a href="classTIGLMutationMessage.html#ab9271622ced744b984d48b1d7279aa9c">TIGLMutationMessage::writeEdgeMessage</a></div><div class="ttdeci">bool writeEdgeMessage(MUTATION_MESSAGE_CODE code, EdgeType *edge, ID_TYPE *targetVertex)</div><div class="ttdoc">Procedure for writing ADD edge messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:548</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a59efe7d8e43b57679710b703462e809d"><div class="ttname"><a href="classTIGLMutationMessage.html#a59efe7d8e43b57679710b703462e809d">TIGLMutationMessage::writeSimpleVertexMessage</a></div><div class="ttdeci">bool writeSimpleVertexMessage(MUTATION_MESSAGE_CODE code, ID_TYPE *id)</div><div class="ttdoc">Procedure for writing add empty/remove vertex messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:617</div></div>
<div class="ttc" id="classTIGLApiTester_html_a97fa334a3aa9c52e3aef64ea1849a519"><div class="ttname"><a href="classTIGLApiTester.html#a97fa334a3aa9c52e3aef64ea1849a519">TIGLApiTester::testMutationManagerModule</a></div><div class="ttdeci">bool testMutationManagerModule(char *fileName)</div><div class="ttdoc">Test procedure for mutation manager with single device. </div><div class="ttdef"><b>Definition:</b> tiglImplementationTester.hpp:86</div></div>
<div class="ttc" id="tiglApiTester_8hpp_html"><div class="ttname"><a href="tiglApiTester_8hpp.html">tiglApiTester.hpp</a></div></div>
<div class="ttc" id="classTIGLApiTester_html_a357fcce3cfa65b607b3f2bb9e94142f8"><div class="ttname"><a href="classTIGLApiTester.html#a357fcce3cfa65b607b3f2bb9e94142f8">TIGLApiTester::getVertex</a></div><div class="ttdeci">bool getVertex(ID_TYPE id, ALG_VERTEX_TYPE *pVertex)</div><div class="ttdoc">Retrieves a vertex. </div><div class="ttdef"><b>Definition:</b> tiglImplementationTester.hpp:68</div></div>
<div class="ttc" id="classTIGLMutationMessage_html"><div class="ttname"><a href="classTIGLMutationMessage.html">TIGLMutationMessage</a></div><div class="ttdoc">Core mutation Massage container class. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessage.hpp:70</div></div>
<div class="ttc" id="group__misc__tools_html_gaba06990768c6b572ca3f69029334a9df"><div class="ttname"><a href="group__misc__tools.html#gaba06990768c6b572ca3f69029334a9df">omp_get_thread_num</a></div><div class="ttdeci">int omp_get_thread_num()</div><div class="ttdoc">Overridden openMP routines. </div><div class="ttdef"><b>Definition:</b> tiglUtilsOmpTools.cpp:52</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
